--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB4 = CreateFrame("Frame","AB4Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	--MoverAB4:SetSize((ButtonSize * 12)+12, ButtonSize)
	MoverAB4:SetPoint("RIGHT", UIParent,-10, 145)
	MoverAB4:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB4:SetClampedToScreen(true)
	MoverAB4:SetClampRectInsets(0, 0, 0,0)
local MoverAB4Text  = MoverAB4:CreateFontString(nil, "OVERLAY")
	MoverAB4Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB4Text:SetPoint("CENTER",MoverAB4,"CENTER", 0,0); 
	MoverAB4Text:SetText("")

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB4:GetPoint(n)
			Inked.db.profile.MoverAB4X = xOfs
			Inked.db.profile.MoverAB4Y = yOfs
			Inked.db.profile.MoverAB4Point = point
			MoverAB4Text:SetText("Inked Bar 5")
			--MoverAB4:SetPoint(Inked.db.profile.MoverAB4Point, UIParent,Inked.db.profile.MoverAB4X,Inked.db.profile.MoverAB4Y)			
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function MakeBar4()
	if Inked.db.profile.UseActionBars == false then return end
	local Bar4holder = CreateFrame("Frame", "Bar4holder", UIParent, "SecureHandlerStateTemplate")
	Bar4holder:ClearAllPoints()
	Bar4holder:SetSize(ButtonSize * 12 + MySpacing * 11, ButtonSize)	

	ButtonSize = Inked.db.profile.AB4ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		if MultiBarLeftButton1:IsVisible() then
			for i = 1, 12 do
					local Holder = CreateFrame("Frame",nil,UIParent)
						Holder:SetWidth(ButtonSize)
						Holder:SetHeight(ButtonSize)
						Holder:SetPoint("CENTER", _G["MultiBarLeftButton"..i],"CENTER",0, 0)
						Holder:CreateBeautyBorder(BorderSize)
						Holder:SetBeautyBorderPadding(BorderPadding)
						Holder:SetBeautyBorderTexture("white")
						--Holder:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
						if Inked.db.profile.ClassABColor == true then
									Holder:SetBeautyBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
								elseif Inked.db.profile.ClassABColor == false then
									if Inked.db.profile.CustomABColor == true then
										Holder:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
									elseif Inked.db.profile.CustomABColor == false then
										Holder:SetBeautyBorderColor(1,1,1,1)
									end
								end
			end
		end
		
		if Inked.db.profile.AB4Layout == 1 then
		--print("layout 1")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)
				
			end
			MoverAB54:SetSize((ButtonSize * 12)+12, ButtonSize)
			Bar4holder:SetPoint("LEFT", MoverAB4, 0,-ButtonSize/1.75)
		end
		if Inked.db.profile.AB4Layout == 2 then
	--	print("layout 2")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			_G["MultiBarLeftButton7"]:ClearAllPoints();
			_G["MultiBarLeftButton7"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton1, 0, -ButtonSize+(-MySpacing*1.5))
			for i = 2, 6 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 8,12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB4:SetSize((ButtonSize * 6)+12, (ButtonSize*2) +12)
			Bar4holder:SetPoint("LEFT", MoverAB4, 0,(ButtonSize*0.25))
		end
		if Inked.db.profile.AB4Layout == 3 then
		--print("layout 3")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			_G["MultiBarLeftButton5"]:ClearAllPoints();
			_G["MultiBarLeftButton5"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton1, 0, -ButtonSize+(-MySpacing*4))
			_G["MultiBarLeftButton9"]:ClearAllPoints();
			_G["MultiBarLeftButton9"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton5, 0, -ButtonSize+(-MySpacing*2))
			for i = 2, 4 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)	
			end
			for i = 6,8 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			for i = 10,12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",ButtonSize+(MySpacing*1.5), 0)			
			end
			MoverAB4:SetSize((ButtonSize * 4), (ButtonSize*3))
			Bar4holder:SetPoint("LEFT", MoverAB4, 0, ButtonSize/1.75)
		end
		if Inked.db.profile.AB4Layout == 4 then
		--print("layout 4")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			for i = 2, 12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))
				
			end
			MoverAB4:SetSize(ButtonSize, (ButtonSize*12) +12)
			Bar4holder:SetPoint("LEFT", MoverAB4, 0,(ButtonSize*5.25))
		end
		if Inked.db.profile.AB4Layout == 5 then
		--print("layout 5")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			_G["MultiBarLeftButton7"]:ClearAllPoints();
			_G["MultiBarLeftButton7"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton1, -ButtonSize+(-MySpacing*1.5), 0)
			for i = 2, 6 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 8,12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB4:SetSize((ButtonSize * 2)+12, (ButtonSize*6) +12)
			Bar4holder:SetPoint("LEFT", MoverAB4, ButtonSize,(ButtonSize*2.25))
		end
		if Inked.db.profile.AB4Layout == 6 then
		--print("layout 6")
			MultiBarLeftButton1:ClearAllPoints()
			MultiBarLeftButton1:SetPoint("BOTTOMLEFT", Bar4holder, 0, 0)
			_G["MultiBarLeftButton5"]:ClearAllPoints();
			_G["MultiBarLeftButton5"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton1, -ButtonSize+(-MySpacing*1.5), 0)
			_G["MultiBarLeftButton9"]:ClearAllPoints();
			_G["MultiBarLeftButton9"]:SetPoint("BOTTOMLEFT", MultiBarLeftButton5, -ButtonSize+(-MySpacing*1.5), 0)

			for i = 2, 4 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 6, 8 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))	
			end
			for i = 10,12 do	
				_G["MultiBarLeftButton"..i]:ClearAllPoints();
				_G["MultiBarLeftButton"..i]:SetPoint("CENTER", _G["MultiBarLeftButton"..i-1],"CENTER",0, -ButtonSize+(-MySpacing*1.5))			
			end
			MoverAB4:SetSize((ButtonSize * 3)+12, (ButtonSize*4) +12)
			Bar4holder:SetPoint("LEFT", MoverAB4, (ButtonSize*2)+2,(ButtonSize*1.25))
		end	
		
		for i = 1, 12 do
			local InkedBar4 = _G["MultiBarLeftButton"..i]
			_G["MultiBarLeftButton"..i]:SetWidth(ButtonSize)
			_G["MultiBarLeftButton"..i]:SetHeight(ButtonSize)
			-- _G["MultiBarLeftButton"..i]:CreateBeautyBorder(BorderSize)
			-- _G["MultiBarLeftButton"..i]:SetBeautyBorderPadding(BorderPadding)
			-- _G["MultiBarLeftButton"..i]:SetBeautyBorderTexture("white")
		--	_G["MultiBarLeftButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			-- if Inked.db.profile.ClassAB4Color == true then
				-- _G["MultiBarLeftButton"..i]:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
			-- elseif Inked.db.profile.ClassAB4Color == false then
				-- if Inked.db.profile.CustomAB4Color == true then
					-- _G["MultiBarLeftButton"..i]:SetBeautyBorderColor(Inked.db.profile.AB4ColorR,Inked.db.profile.AB4ColorG,Inked.db.profile.AB4ColorB,Inked.db.profile.AB4ColorA)
				-- elseif Inked.db.profile.CustomAB4Color == false then
					-- _G["MultiBarLeftButton"..i]:SetBeautyBorderColor(1,1,1,1)
				-- end
			-- end

			InkedBar4:SetAttribute("showgrid", 1)
			InkedBar4:SetAttribute("statehidden", false)
			InkedBar4.NormalTexture:SetTexture("")
			local Highlight = InkedBar4:GetHighlightTexture()	
			local Pushed = InkedBar4:GetPushedTexture()
			Highlight:SetTexture(HightlightTex)
			Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
			Pushed:SetTexture(PushedTex)		
		end

		if(Inked.db.profile.lockframes == false) then
			MoverAB4:ClearAllPoints()
			if Inked.db.profile.MoverAB4Point == nil then
				MoverAB4:SetPoint("RIGHT", UIParent,Inked.db.profile.MoverAB4X,Inked.db.profile.MoverAB4Y)
			else
				MoverAB4:SetPoint(Inked.db.profile.MoverAB4Point, UIParent,Inked.db.profile.MoverAB4X,Inked.db.profile.MoverAB4Y)
			end
			CreateMoverBackdrop(MoverAB4)
			MoverAB4:SetMovable(true)
			MoverAB4:EnableMouse(true)
			MoverAB4:RegisterForDrag("LeftButton")
			MoverAB4:SetScript("OnDragStart", MoverAB4.StartMoving)
			MoverAB4:SetScript("OnDragStop", MoverAB4.StopMovingOrSizing)
			MoverAB4:SetUserPlaced(true)
						
		elseif Inked.db.profile.MoverAB4Point == nil then
				MoverAB4:SetPoint("RIGHT", UIParent,Inked.db.profile.MoverAB4X,Inked.db.profile.MoverAB4Y)
			else
				MoverAB4:SetPoint(Inked.db.profile.MoverAB4Point, UIParent,Inked.db.profile.MoverAB4X,Inked.db.profile.MoverAB4Y)
		end
		--if(Inked.db.profile.lockframes == true) then
			-- Bar4holder:ClearAllPoints()
			-- Bar4holder:SetPoint("LEFT", MoverAB4, 0, 0)
		--end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar4()									
		end)